<Query Kind="Program">
  <Namespace>System.Text.Json</Namespace>
  <Namespace>System.Text.Json.Serialization</Namespace>
</Query>

void Main()
{
	var home = new Address { Street = "1 Main St.", PostCode = "11235" };
	
	var p = new Person { Name = "Ian", HomeAddress = home, WorkAddress = home };

	var options = new JsonSerializerOptions
	{
		WriteIndented = true,
		ReferenceHandler = ReferenceHandler.Preserve
	};

	string json = JsonSerializer.Serialize (p, options).Dump();
		
	var p2 = (Person) JsonSerializer.Deserialize (json, typeof (Person), options);
	(p2.HomeAddress == p2.WorkAddress).Dump ("Object references preserved");
}

public class Address
{
	public string Street { get; set; }
	public string PostCode { get; set; }
}

public class Person
{
	public string Name { get; set; }
	public Address HomeAddress { get; set; }
	public Address WorkAddress { get; set; }
}