<Query Kind="Program">
  <Namespace>System.Runtime.Serialization</Namespace>
  <Namespace>SerialTest</Namespace>
  <Namespace>System.Collections.ObjectModel</Namespace>
</Query>

void Main()
{
	Person p = new Person
	{
		Name = "Li",
		Addresses = new AddressList
		{
			new Address { Postcode = "1000", Street = "One" },
			new USAddress { Postcode = "2000", Street = "Two" },
		}
	};  

	var ds = new DataContractSerializer (typeof (Person));
	
	using (Stream s = File.Create ("person.xml"))
		ds.WriteObject (s, p);                            // Serialize 
	
	XDocument.Load ("person.xml").Dump ("XML");
}

namespace SerialTest
{
	[DataContract]
	public class Person
	{
		[DataMember] public string Name;
		[DataMember] public AddressList Addresses;
	}

	[CollectionDataContract (ItemName = "Residence")]
	public class AddressList : Collection<Address> { }

	[DataContract, KnownType (typeof (USAddress))]
	public class Address
	{
		[DataMember] public string Street, Postcode;
	}
	
	public class USAddress : Address { }
}