<Query Kind="Program">
  <Namespace>System.Runtime.Serialization</Namespace>
</Query>

void Main()
{
	Person p = new Person { Name = "John", Age = 30 };
	p.HomeAddress = new USAddress { Street="Fawcett St", Postcode="02138" };
	
	var ds = new DataContractSerializer (typeof (Person));
	
	using (Stream s = File.Create ("person.xml"))
		ds.WriteObject (s, p);                            // Serialize
		
	XDocument.Load ("person.xml").Dump ("XML");
}

[DataContract]
public class Person
{
	[DataMember] public string Name;
	[DataMember] public int Age;
	[DataMember] public Address HomeAddress;
}

[DataContract, KnownType (typeof (USAddress))]
public class Address
{
	[DataMember] public string Street, Postcode;
}

[DataContract]
public class USAddress : Address { }