<Query Kind="Program">
  <Namespace>System.Runtime.Serialization</Namespace>
</Query>

void Main()
{
	Person p = new Person { Name = "Stacey", Age = 30 };
	p.HomeAddress = new Address { Street = "Odo St", Postcode = "6020" };
	p.WorkAddress = p.HomeAddress;
	
	var settings = new DataContractSerializerSettings { PreserveObjectReferences = true };
	var ds = new DataContractSerializer (typeof (Person), settings);
	
	using (Stream s = File.Create ("person.xml"))
		ds.WriteObject (s, p);                            // Serialize
		
	XDocument.Load ("person.xml").Dump ("XML");
	
	Person p2;
	using (Stream s = File.OpenRead ("person.xml"))
		p2 = (Person)ds.ReadObject (s);                  // Deserialize
	
	(p2.HomeAddress == p2.WorkAddress).Dump ("Referential integrity preserved");
}

[DataContract]
public class Person
{
	[DataMember] public string Name;
	[DataMember] public int Age;
	[DataMember] public Address HomeAddress, WorkAddress;
}

[DataContract, KnownType (typeof (USAddress))]
public class Address
{
	[DataMember] public string Street, Postcode;
}

[DataContract]
public class USAddress : Address { }