<Query Kind="Program">
  <Namespace>System.Runtime.Serialization</Namespace>
</Query>

void Main()
{
	Person person = new Person 
	{
		Name = "Stacey",
		Age = 30,
		HomeAddress = new Address { Postcode = "6000", Street = "Mary St" }
	};
	
	var ds = new DataContractSerializer (typeof (Person));
	
	using (Stream s = File.Create ("person.xml"))
		ds.WriteObject (s, person);                            // Serialize
		
	XDocument.Load ("person.xml").Dump ("XML");
}

[DataContract]
public class Person
{
	[DataMember] public string Name;
	[DataMember] public int Age;
	[DataMember] public Address HomeAddress;
}

[DataContract]
public class Address
{
	[DataMember] public string Street, Postcode;
}