<Query Kind="Program">
  <Namespace>System.Runtime.Serialization</Namespace>
  <Namespace>SerialTest</Namespace>
</Query>

void Main()
{
	Person p = new Person { Name = "Stacey", Age = 30 };
	
	var ds = new DataContractSerializer (typeof (Person));
	
	using (Stream s = File.Create ("person.xml"))
		ds.WriteObject (s, p);                            // Serialize
	
	Person p2;
	using (Stream s = File.OpenRead ("person.xml"))
		p2 = (Person)ds.ReadObject (s);                  // Deserialize
	
	p2.Dump();
	
	XDocument.Load ("person.xml").Dump ("XML");
}

namespace SerialTest
{
	[DataContract]
	public class Person
	{
		[DataMember] public string Name;
		[DataMember] public int Age;

		[OnSerializing]
		void PrepareForSerialization (StreamingContext sc)
		{
			"OnSerializing".Dump();
		}

		[OnDeserialized]
		void CompleteDeserialization (StreamingContext sc)
		{
			"OnDeserialized".Dump();
		}
	}
}