<Query Kind="Program">
  <Namespace>System.Runtime.Serialization</Namespace>
</Query>

void Main()
{
	Person person = new Person { Name = "Stacey", Age = 30 };
	Student student = new Student { Name = "Stacey", Age = 30 };
	Teacher teacher = new Teacher { Name = "Stacey", Age = 30 };
	
	Person p2 = DeepClone (person);     // OK
	Student s2 = (Student)DeepClone (student);    // SerializationException
	Teacher t2 = (Teacher)DeepClone (teacher);    // SerializationException
	
	p2.Dump ("Person clone");
	s2.Dump ("Student clone");
	t2.Dump ("Teacher clone");
}

static Person DeepClone (Person p)
{
	var ds = new DataContractSerializer (typeof (Person), 
		new Type[] { typeof (Student), typeof (Teacher) });
		
	MemoryStream stream = new MemoryStream();
	ds.WriteObject (stream, p);
	stream.Position = 0;
	DumpXmlStream (stream);
	return (Person)ds.ReadObject (stream);
}

static void DumpXmlStream (Stream s)
{
	XDocument.Load (s).Dump ("XML");
	s.Position = 0;  
}

[DataContract]
public class Person
{
	[DataMember] public string Name;
	[DataMember] public int Age;
}

[DataContract] public class Student : Person { }

[DataContract] public class Teacher : Person { }