<Query Kind="Statements">
  <Connection>
    <ID>f2f6e2b4-0f40-48df-b2c7-82584a77c394</ID>
    <Driver Assembly="(internal)" PublicKeyToken="no-strong-name">LINQPad.Drivers.EFCore.DynamicDriver</Driver>
    <AttachFile>true</AttachFile>
    <Server>(localdb)\MSSQLLocalDB</Server>
    <AttachFileName>&lt;ApplicationData&gt;\LINQPad\Nutshell.mdf</AttachFileName>
    <DisplayName>Nutshell</DisplayName>
    <Persist>true</Persist>
    <DriverData>
      <EFProvider>Microsoft.EntityFrameworkCore.SqlServer</EFProvider>
    </DriverData>
  </Connection>
  <NuGetReference>System.Data.SqlClient</NuGetReference>
  <Namespace>System.Dynamic</Namespace>
  <Namespace>System.Data.SqlClient</Namespace>
  <Namespace>System.Data.Common</Namespace>
</Query>

var command = this.Database.GetDbConnection().CreateCommand();
command.CommandText = "select top 3 * from Purchase";
Connection.Open();
using (IDataReader reader = command.ExecuteReader (CommandBehavior.CloseConnection))
{
	dynamic dr = new DynamicReader (reader);
	while (reader.Read())
	{
		int id = dr.ID;
		string description = dr.Description;
		DateTime date = dr.Date;
		decimal price = dr.Price;
		new { description, date, price }.Dump();
	}
}

public class DynamicReader : DynamicObject
{
	readonly IDataRecord _dataRecord;
	public DynamicReader (IDataRecord dr) { _dataRecord = dr; }

	public override bool TryGetMember (GetMemberBinder binder,
                      out object result)
	{
		result = _dataRecord [binder.Name];
		return true;
	}
}