<Query Kind="Statements" />

// The nint and unint native-sized integer types are sized to match the address space
// of the processor and operating system at runtime (in practice, 32 or 64 bits).

// Native-sized integers behave much like standard integers, with support
// for arithmetic operations, overflow check operators, and so on:

nint x = 123;
nint y = 234;
nint product = x * y;

product.Dump();

// You can implicitly convert between nint/unint and IntPtr/UIntPtr:

IntPtr p = x;
y = p;

// Arithmetic is supported *only* with nint/unint, so the following does not compile:
// (p * p).Dump();