<Query Kind="Statements" />

// The contextual keyword var implicitly types local variables:
{
	System.Text.StringBuilder sb1 = new();
	System.Text.StringBuilder sb2 = new ("Test");
}

// This is precisely equivalent to:
{
	System.Text.StringBuilder sb1 = new System.Text.StringBuilder();
	System.Text.StringBuilder sb2 = new System.Text.StringBuilder ("Test");
}

// Target-typed new expressions are helpful when th emethod argument is a constructor call:

MyMethod (new ("test"));
void MyMethod (StringBuilder sb) { }

// They're also useful when the variable declaration and initialization are in different
// parts of your code:

class Foo
{
	System.Text.StringBuilder sb;

	public Foo (string initialValue)
	{
		sb = new (initialValue);
	}
}