<Query Kind="Statements" />

Point p1 = new Point (2, 3);
Console.WriteLine (p1.DistanceFromOrigin);

record Point
{
	public double X { get; }
	public double Y { get; }
	public double DistanceFromOrigin { get; }
	
	// We calculate DistanceFromOrigin just once.
	// This works, but doesn't allow for non-destructive mutation.

	public Point (double x, double y) =>
		(X, Y, DistanceFromOrigin) = (x, y, Math.Sqrt (x * x + y * y));
}